
rm(list=ls())
crab = read.table(file="crab.txt", header=TRUE)
F_CRL = read.table(file='Outoupt_F_CRL.txt', sep=",") # 216.6331
numCls = dim(F_CRL)[2]
crab$y = rowSums( as.matrix(F_CRL[, -numCls]) %*% diag(1:(numCls-1)) ) 
# crab$y = as.factor(crab$y)
#################### CART
library(rpart)
#### A first try, using the crab data
tree <- rpart(as.factor(y)~ ., data=crab, method="class")
plot(tree, compress=TRUE, uniform=TRUE)
text(tree, use.n=TRUE); #title("Bi-class")
post(tree, title='final tree', filename='finaltree.ps')

summary(lm(satell~width+I(color>=5), data=crab))
summary(lm(satell~width+I(color>=5), data=crab, subset=which(crab$y==0)))
summary(lm(satell~width+I(color>=5), data=crab, subset=which(crab$y==1)))

ecdf(crab$width)(28.7) # 0.8786127
max(crab$width) # 33.5
ecdf(crab$satell)(3.5) # 0.6127168
max(crab$satell) # 15
sum(crab$y == 0) # 117
sum(crab$y == 1) # 56
