function [F, G] = Func_Loss_Grad_Balpha(Y, X, B, alpha, lossType, gradDesired, scale)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate the loss function value and its gradient function value given
% B, alpha. This is a wrapper of Func_Loss_Grad. See more details there.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if ~exist('scale', 'var') || isempty('scale')
    scale = 1;
end
if ~exist('gradDesired', 'var') || isempty('gradDesired')
    gradDesired = 2;
end

[Theta] = Func_Eval_Theta_SysComp(X, B, alpha, lossType); % For ordinary models, Theta = X * B_est + 1 * alpha_est';
[F, G] = Func_Loss_Grad(Y, Theta, lossType, gradDesired, scale); 
